(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.module = f()}})(function(){var define,module,exports;return (function(){function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s}return e})()({1:[function(require,module,exports){

const events = {
    update: function(ui) {
        calcModelTerms(ui, this);
        filterModelTerms(ui, this);
        updatePostHocSupplier(ui, this);
    },

    onChange_factors: function(ui) {
        calcModelTerms(ui, this);
        updatePostHocSupplier(ui, this);
    },

    onChange_covs: function(ui) {
        calcModelTerms(ui, this);
    },

    onChange_random: function(ui) {
        calcModelTerms(ui, this);
        updatePostHocSupplier(ui, this);
    },

    onChange_modelTerms: function(ui) {
        filterModelTerms(ui, this);
    },

    onUpdate_modelSupplier: function(ui) {
        let variableList = this.cloneArray(ui.factors.value(), []);
        let covariatesList = this.cloneArray(ui.covs.value(), []);
        let randomList = this.cloneArray(ui.random.value(), []);
        let combinedList = variableList.concat(randomList).concat(covariatesList);

        ui.modelSupplier.setValue(this.valuesToItems(combinedList, FormatDef.variable));
    },

    onUpdate_postHocSupplier: function(ui) {
        updatePostHocSupplier(ui, this);
    },

    onUpdate_plotsSupplier: function(ui) {
        let variableList = this.cloneArray(ui.factors.value(), []);
        let randomList = this.cloneArray(ui.random.value(), []);

        ui.plotsSupplier.setValue(this.valuesToItems(variableList.concat(randomList), FormatDef.variable));
    },

    onChange_plotsSupplier: function(ui) {
        let values = this.itemsToValues(ui.plotsSupplier.value());
        this.checkValue(ui.plotHz, false, values, FormatDef.variable);
        this.checkValue(ui.plotLines, false, values, FormatDef.variable);
        this.checkValue(ui.plotSep, false, values, FormatDef.variable);
    },

    onChange_postHocSupplier: function(ui) {
        let values = this.itemsToValues(ui.postHocSupplier.value());
        this.checkValue(ui.postHoc, true, values, FormatDef.variable);
    }
};


var calcModelTerms = function(ui, context) {
    var variableList = context.cloneArray(ui.factors.value(), []);
    var covariatesList = context.cloneArray(ui.covs.value(), []);
    var randomList = context.cloneArray(ui.random.value(), []);

    ui.plotsSupplier.setValue(context.valuesToItems(variableList.concat(randomList), FormatDef.variable));

    var combinedList = variableList.concat(randomList).concat(covariatesList);

    ui.modelSupplier.setValue(context.valuesToItems(combinedList, FormatDef.variable));

    var diff = context.findChanges("variableList", variableList, true, FormatDef.variable);
    var diff2 = context.findChanges("covariatesList", covariatesList, true, FormatDef.variable);
    var diff3 = context.findChanges("randomList", randomList, true, FormatDef.variable);
    var combinedDiff = context.findChanges("combinedList", combinedList, true, FormatDef.variable);

    var termsList = context.cloneArray(ui.modelTerms.value(), []);
    var termsChanged = false;

    for (var i = 0; i < combinedDiff.removed.length; i++) {
        for (var j = 0; j < termsList.length; j++) {
            if (FormatDef.term.contains(termsList[j].components, combinedDiff.removed[i])) {
                termsList.splice(j, 1);
                termsChanged = true;
                j -= 1;
            }
        }
    }

    for (var a = 0; a < diff.added.length; a++) {
        let item = diff.added[a];
        var listLength = termsList.length;
        for (var j = 0; j < listLength; j++) {
            var newTerm = context.clone(termsList[j].components);
            if (containsCovariate(newTerm, covariatesList) === false && containsCovariate(newTerm, randomList) === false) {
                if (context.listContains(newTerm, item, FormatDef.variable) === false) {
                    newTerm.push(item)
                    if (context.listContains(termsList, newTerm , FormatDef.term, 'components') === false) {
                        termsList.push({ components: newTerm, isNuisance: false });
                        termsChanged = true;
                    }
                }
            }
        }
        if (context.listContains(termsList, [item] , FormatDef.term, 'components') === false) {
            termsList.push({ components: [item], isNuisance: false });
            termsChanged = true;
        }
    }

    for (var a = 0; a < diff3.added.length; a++) {
        let item = diff3.added[a];
        if (context.listContains(termsList, [item] , FormatDef.term, 'components') === false) {
            termsList.push({ components: [item], isNuisance: true });
            termsChanged = true;
        }
    }

    for (var a = 0; a < diff2.added.length; a++) {
        let item = diff2.added[a];
        if (context.listContains(termsList, [item] , FormatDef.term, 'components') === false) {
            termsList.push({ components: [item], isNuisance: false });
            termsChanged = true;
        }
    }



    if (termsChanged)
        ui.modelTerms.setValue(termsList);
};

var updatePostHocSupplier = function(ui, context) {
    var variableList = context.cloneArray(ui.factors.value(), []);
    var randomList = context.cloneArray(ui.random.value(), []);

    var list = variableList.concat(randomList);

    ui.postHocSupplier.setValue(context.valuesToItems(list, FormatDef.variable));
};

var filterModelTerms = function(ui, context) {
    var termsList = context.cloneArray(ui.modelTerms.value(), []);
    var diff = context.findChanges("termsList", termsList, true, FormatDef.term, 'components');

    var changed = false;
    if (diff.removed.length > 0) {
        var itemsRemoved = false;
        for (var i = 0; i < diff.removed.length; i++) {
            var item = diff.removed[i];
            for (var j = 0; j < termsList.length; j++) {
                if (FormatDef.term.contains(termsList[j].components, item.components)) {
                    termsList.splice(j, 1);
                    j -= 1;
                    itemsRemoved = true;
                }
            }
        }

        if (itemsRemoved)
            changed = true;
    }

    if (context.sortArraysByLength(termsList, 'components'))
        changed = true;

    if (changed)
        ui.modelTerms.setValue(termsList);
};

var containsCovariate = function(value, covariates) {
    for (var i = 0; i < covariates.length; i++) {
        if (FormatDef.term.contains(value, covariates[i]))
            return true;
    }

    return false;
};


module.exports = events;

},{}],2:[function(require,module,exports){

// This file is an automatically generated and should not be edited

'use strict';

const options = [{"name":"data","type":"Data"},{"name":"dep","title":"Dependent Variable","type":"Variable"},{"name":"factors","title":"Fixed Factors","type":"Variables"},{"name":"random","title":"Random Factors","type":"Variables","default":null},{"name":"covs","title":"Covariates","type":"Variables"},{"name":"bfType","title":"Bayes factor","type":"List","options":[{"name":"BF10","title":"BF₁₀"},{"name":"BF01","title":"BF₀₁"}],"default":"BF10"},{"name":"order","title":"Order","type":"List","options":[{"name":"nullModelTop","title":"Compare to null model"},{"name":"bestModelTop","title":"Compare to best model"}],"default":"nullModelTop"},{"name":"effects","title":"Effects","type":"Bool","default":false},{"name":"desc","title":"Descriptives","type":"Bool","default":false},{"name":"effectsType","title":"Effects type","type":"List","options":[{"name":"allModels","title":"Across all models"},{"name":"matchedModels","title":"Across matched models"}],"default":"allModels"},{"name":"modelTerms","title":"Model Terms","type":"Array","default":null,"template":{"type":"Group","elements":[{"name":"components","type":"Term"},{"name":"isNuisance","type":"Bool"}]}},{"name":"postHoc","title":"Post-hoc tests","type":"Variables","default":null},{"name":"postHocCorr","title":"Post-hoc correction","type":"Bool","default":true},{"name":"plotHz","title":"Horizontal axis","type":"Variable","default":null},{"name":"plotLines","title":"Separate lines","type":"Variable","default":null},{"name":"plotSep","title":"Separate plots","type":"Variable","default":null},{"name":"plotCI","title":"Credible interval","type":"Bool","default":false},{"name":"ciWidth","title":"Credible interval width","type":"Number","default":95,"min":50,"max":99.9},{"name":"rScaleFixed","title":"r scale fixed effects","type":"Number","default":0.5},{"name":"rScaleRand","title":"r scale random effects","type":"Number","default":1},{"name":"rScaleCovs","title":"r scale covariates","type":"Number","default":0.354},{"name":"sampling","title":"Samples","type":"List","options":[{"name":"auto","title":"Auto"},{"name":"manual","title":"Manual"}],"default":"auto"},{"name":"nSamples","title":"No. samples","type":"Integer","default":10000}];

const view = function() {
    
    

    View.extend({
        jus: "2.0",

        events: [

	],

	update: require('./bancova.events').update

    }).call(this);
}

view.layout = ui.extend({

    label: "Bayesian ANCOVA",
    jus: "2.0",
    type: "root",
    stage: 0, //0 - release, 1 - development, 2 - proposed
    controls: [
		{
			type: DefaultControls.VariableSupplier,
			typeName: 'VariableSupplier',
			persistentItems: false,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					label: "Dependent Variable",
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "dep",
							maxItemCount: 1,
							isTarget: true
						}
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					label: "Fixed Factors",
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "factors",
							height: "small",
							isTarget: true,
							events: [
								{ execute: require('./bancova.events').onChange_factors }
							]
						}
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					label: "Random Factors",
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "random",
							height: "small",
							isTarget: true,
							events: [
								{ execute: require('./bancova.events').onChange_random }
							]
						}
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					label: "Covariates",
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "covs",
							height: "small",
							isTarget: true,
							events: [
								{ execute: require('./bancova.events').onChange_covs }
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.LayoutBox,
			typeName: 'LayoutBox',
			margin: "large",
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Bayes Factor",
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "bfType_BF10",
									optionName: "bfType",
									optionPart: "BF10",
									label: "BF₁₀"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "bfType_BF01",
									optionName: "bfType",
									optionPart: "BF01",
									label: "BF₀₁"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Order",
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "order_nullModelTop",
									optionName: "order",
									optionPart: "nullModelTop",
									label: "Compare to null model"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "order_bestModelTop",
									optionName: "order",
									optionPart: "bestModelTop",
									label: "Compare to best model"
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					cell: {"column":1,"row":0},
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Output",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "effects",
									controls: [
										{
											type: DefaultControls.RadioButton,
											typeName: 'RadioButton',
											name: "effectsType_allModels",
											optionName: "effectsType",
											optionPart: "allModels",
											label: "Across all models",
											enable: "(effects)"
										},
										{
											type: DefaultControls.RadioButton,
											typeName: 'RadioButton',
											name: "effectsType_matchedModels",
											optionName: "effectsType",
											optionPart: "matchedModels",
											label: "Across matched models",
											enable: "(effects)"
										}
									]
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "desc"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Model",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.VariableSupplier,
					typeName: 'VariableSupplier',
					populate: "manual",
					name: "modelSupplier",
					label: "Components",
					persistentItems: true,
					stretchFactor: 1,
					events: [
						{ onEvent: 'update', execute: require('./bancova.events').onUpdate_modelSupplier }
					],
					controls: [
						{
							type: DefaultControls.TargetLayoutBox,
							typeName: 'TargetLayoutBox',
							transferAction: "interactions",
							stretchFactor: 2,
							controls: [
								{
									type: DefaultControls.ListBox,
									typeName: 'ListBox',
									name: "modelTerms",
									valueFilter: "unique",
									isTarget: true,
									itemDropBehaviour: "emptyspace",
									showColumnHeaders: true,
									events: [
										{ execute: require('./bancova.events').onChange_modelTerms }
									],
									columns: [
										{
											name: "components",
											label: "Terms",
											selectable: true,
											stretchFactor: 1,
											maxWidth: 300,
											template:
											{
												type: DefaultControls.TermLabel,
												typeName: 'TermLabel'
											}											
										},
										{
											name: "isNuisance",
											label: "Null",
											selectable: false,
											stretchFactor: 0.3,
											template:
											{
												type: DefaultControls.CheckBox,
												typeName: 'CheckBox',
												label: "",
												horizontalAlignment: "center"
											}											
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Post-Hoc Tests",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.VariableSupplier,
					typeName: 'VariableSupplier',
					name: "postHocSupplier",
					persistentItems: false,
					stretchFactor: 1,
					populate: "manual",
					events: [
						{ execute: require('./bancova.events').onChange_postHocSupplier },
						{ onEvent: 'update', execute: require('./bancova.events').onUpdate_postHocSupplier }
					],
					controls: [
						{
							type: DefaultControls.TargetLayoutBox,
							typeName: 'TargetLayoutBox',
							controls: [
								{
									type: DefaultControls.VariablesListBox,
									typeName: 'VariablesListBox',
									name: "postHoc",
									isTarget: true
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Correction",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "postHocCorr",
									label: "Null control"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Descriptive Plots",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.VariableSupplier,
					typeName: 'VariableSupplier',
					name: "plotsSupplier",
					persistentItems: false,
					stretchFactor: 1,
					populate: "manual",
					events: [
						{ execute: require('./bancova.events').onChange_plotsSupplier },
						{ onEvent: 'update', execute: require('./bancova.events').onUpdate_plotsSupplier }
					],
					controls: [
						{
							type: DefaultControls.TargetLayoutBox,
							typeName: 'TargetLayoutBox',
							label: "Horizontal axis",
							controls: [
								{
									type: DefaultControls.VariablesListBox,
									typeName: 'VariablesListBox',
									name: "plotHz",
									maxItemCount: 1,
									isTarget: true
								}
							]
						},
						{
							type: DefaultControls.TargetLayoutBox,
							typeName: 'TargetLayoutBox',
							label: "Separate lines",
							controls: [
								{
									type: DefaultControls.VariablesListBox,
									typeName: 'VariablesListBox',
									name: "plotLines",
									maxItemCount: 1,
									isTarget: true
								}
							]
						},
						{
							type: DefaultControls.TargetLayoutBox,
							typeName: 'TargetLayoutBox',
							label: "Separate plots",
							controls: [
								{
									type: DefaultControls.VariablesListBox,
									typeName: 'VariablesListBox',
									name: "plotSep",
									maxItemCount: 1,
									isTarget: true
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Display",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "plotCI",
									label: "Credible interval",
									controls: [
										{
											type: DefaultControls.TextBox,
											typeName: 'TextBox',
											name: "ciWidth",
											label: "Interval",
											format: FormatDef.number,
											suffix: "%",
											enable: "(plotCI)"
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Advanced Options",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Prior",
							controls: [
								{
									type: DefaultControls.TextBox,
									typeName: 'TextBox',
									name: "rScaleFixed",
									format: FormatDef.number
								},
								{
									type: DefaultControls.TextBox,
									typeName: 'TextBox',
									name: "rScaleRand",
									format: FormatDef.number
								},
								{
									type: DefaultControls.TextBox,
									typeName: 'TextBox',
									name: "rScaleCovs",
									format: FormatDef.number
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Samples",
							cell: {"row":0,"column":1},
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "sampling_auto",
									optionName: "sampling",
									optionPart: "auto",
									label: "Auto"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "sampling_manual",
									optionName: "sampling",
									optionPart: "manual",
									label: "Manual",
									controls: [
										{
											type: DefaultControls.TextBox,
											typeName: 'TextBox',
											name: "nSamples",
											label: "No. samples",
											format: FormatDef.number,
											enable: "(sampling_manual)"
										}
									]
								}
							]
						}
					]
				}
			]
		}
	]
});

module.exports = { view : view, options: options };

},{"./bancova.events":1}]},{},[2])(2)
});