(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.module = f()}})(function(){var define,module,exports;return (function(){function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s}return e})()({1:[function(require,module,exports){

var rma_cell = require('./rmacell');

const events = {
    update: function(ui) {
        this._factorCells = null;

        this.initializeValue(ui.modelTerms, [{ components: ["RM Factor 1"], isNuisance: false }]);
        this.setCustomVariable("RM Factor 1", "none", []);

        updateFactorCells(ui, this);
        updateModelTerms(ui, this);
        filterModelTerms(ui, this);
    },

    onChange_rm: function(ui) {
        updateFactorCells(ui, this);
        updateModelTerms(ui, this);
    },

    onChange_rmCells: function(ui) {
        filterCells(ui, this);
    },

    onChange_bs: function(ui) {
        updateModelTerms(ui, this);
    },

    onChange_covs: function(ui) {
        updateModelTerms(ui, this);
    },

    onUpdate_modelSupplier: function(ui) {
        let variableList = this.cloneArray(ui.bs.value(), []);
        let randomList = this.cloneArray(ui.covs.value(), []);
        let factorList = this.cloneArray(ui.rm.value(), []);

        //let customVariables = [];
        for(let i = 0; i < factorList.length; i++) {
        //    customVariables.push( { name: factorList[i].label, measureType: 'none', dataType: 'none', levels: [] } );
            factorList[i] = factorList[i].label;
        }
        //this.setCustomVariables(customVariables);

        let combinedList = factorList.concat(variableList).concat(randomList);

        ui.modelSupplier.setValue(this.valuesToItems(combinedList, FormatDef.variable));
    },

    onUpdate_postHocSupplier: function(ui) {
        let variableList = this.cloneArray(ui.bs.value(), []);
        let factorList = this.cloneArray(ui.rm.value(), []);

        //let customVariables = [];
        for(let i = 0; i < factorList.length; i++) {
        //    customVariables.push( { name: factorList[i].label, measureType: 'none', dataType: 'none', levels: [] } );
            factorList[i] = factorList[i].label;
        }
        //this.setCustomVariables(customVariables);
        let varList = factorList.concat(variableList);

        ui.postHocSupplier.setValue(this.valuesToItems(varList, FormatDef.variable));
    },

    onUpdate_plotsSupplier: function(ui) {
        let variableList = this.cloneArray(ui.bs.value(), []);
        let factorList = this.cloneArray(ui.rm.value(), []);

        //let customVariables = [];
        for(let i = 0; i < factorList.length; i++) {
        //    customVariables.push( { name: factorList[i].label, measureType: 'none', dataType: 'none', levels: [] } );
            factorList[i] = factorList[i].label;
        }
        //this.setCustomVariables(customVariables);
        let varList = factorList.concat(variableList);

        ui.plotsSupplier.setValue(this.valuesToItems(varList, FormatDef.variable));
    },

    onChange_modelTerms: function(ui) {
        filterModelTerms(ui, this);
    },

    onChange_postHocSupplier: function(ui) {
        let values = this.itemsToValues(ui.postHocSupplier.value());
        this.checkValue(ui.postHoc, true, values, FormatDef.term);
    }
};

let updateModelLabels = function(list, blockName) {
    list.applyToItems(0, (item, index) => {
        item.controls[0].setPropertyValue("label", blockName + " " + (index + 1) );
    });
};

var updateFactorCells = function(ui, context) {
    var value = ui.rm.value();
    if (value === null)
        return;

    var data = []
    var indices = []
    for (var i = 0; i < value.length; i++) {
        indices[i] = 0;
    }

    var end = false;
    var pos = 0;
    while (end === false) {
        var cell = []
        for (var k = 0; k < indices.length; k++) {
            cell.push(value[k].levels[indices[k]])
        }
        data.push(cell);
        pos += 1;
        var zeroCount = 0;

        var r = indices.length - 1;
        if (r < 0)
            end = true;
        while (r >= 0) {
            indices[r] = (indices[r] + 1) % value[r].levels.length;
            if (indices[r] === 0)
                r -= 1;
            else
                break;

            if (r === -1)
                end = true;
        }
    }

    context._factorCells = data;
    filterCells(ui, context);
};

var updateModelTerms = function(ui, context) {
    var variableList = context.cloneArray(ui.bs.value(), []);
    var randomList = context.cloneArray(ui.covs.value(), []);
    let factorList = context.cloneArray(ui.rm.value(), []);

    let customVariables = [];
    for(let i = 0; i < factorList.length; i++) {
        customVariables.push( { name: factorList[i].label, measureType: 'none', dataType: 'none', levels: [] } );
        factorList[i] = factorList[i].label;
    }
    context.setCustomVariables(customVariables);
    var combinedList = factorList.concat(variableList).concat(randomList);
    var varList = factorList.concat(variableList);

    ui.plotsSupplier.setValue(context.valuesToItems(varList, FormatDef.variable));
    ui.postHocSupplier.setValue(context.valuesToItems(varList, FormatDef.variable));
    ui.modelSupplier.setValue(context.valuesToItems(combinedList, FormatDef.variable));
    console.log(combinedList)

    var diff = context.findChanges("variableList", varList, true, FormatDef.variable);
    var diff3 = context.findChanges("randomList", randomList, true, FormatDef.variable);
    var combinedDiff = context.findChanges("combinedList", combinedList, true, FormatDef.variable);

    var termsList = context.cloneArray(ui.modelTerms.value(), []);
    var termsChanged = false;

    for (var i = 0; i < combinedDiff.removed.length; i++) {
        for (var j = 0; j < termsList.length; j++) {
            if (FormatDef.term.contains(termsList[j].components, combinedDiff.removed[i])) {
                termsList.splice(j, 1);
                termsChanged = true;
                j -= 1;
            }
        }
    }

    for (var a = 0; a < diff.added.length; a++) {
        let item = diff.added[a];
        var listLength = termsList.length;
        for (var j = 0; j < listLength; j++) {
            var newTerm = context.clone(termsList[j].components);
            if (containsCovariate(newTerm, randomList) === false) {
                if (context.listContains(newTerm, item, FormatDef.variable) === false) {
                    newTerm.push(item)
                    if (context.listContains(termsList, newTerm , FormatDef.term, 'components') === false) {
                        termsList.push({ components: newTerm, isNuisance: false });
                        termsChanged = true;
                    }
                }
            }
        }
        if (context.listContains(termsList, [item] , FormatDef.term, 'components') === false) {
            termsList.push({ components: [item], isNuisance: false });
            termsChanged = true;
        }
    }

    for (var a = 0; a < diff3.added.length; a++) {
        let item = diff3.added[a];
        if (context.listContains(termsList, [item] , FormatDef.term, 'components') === false) {
            termsList.push({ components: [item], isNuisance: true });
            termsChanged = true;
        }
    }

    if (termsChanged)
        ui.modelTerms.setValue(termsList);
};

var updatePostHocSupplier = function(ui, context) {
    //var bsTerms = context.cloneArray(ui.bsTerms.value(), []);
   // var rmTerms = context.cloneArray(ui.rmTerms.value(), []);
   // var combinedTermsList = rmTerms; //.concat(bsTerms);

    /*for (let i = 0; i < rmTerms.length; i++) {
        for (let j = 0; j < bsTerms.length; j++)
            combinedTermsList.push(rmTerms[i].concat(bsTerms[j]))
    }*/

    //ui.postHocSupplier.setValue(context.valuesToItems(combinedTermsList, FormatDef.term));
};

var filterModelTerms = function(ui, context) {
    let termsList = context.cloneArray(ui.modelTerms.value(), []);
    var diff = context.findChanges("modelTerms", termsList, true, FormatDef.term, 'components');

    var changed = false;
    if (diff.removed.length > 0) {
        var itemsRemoved = false;
        for (var i = 0; i < diff.removed.length; i++) {
            var item = diff.removed[i];
            for (var j = 0; j < termsList.length; j++) {
                if (FormatDef.term.contains(termsList[j].components, item.components)) {
                    termsList.splice(j, 1);
                    j -= 1;
                    itemsRemoved = true;
                }
            }
        }

        if (itemsRemoved)
            changed = true;
    }

    if (context.sortArraysByLength(termsList, 'components'))
        changed = true;

    if (changed)
        ui.modelTerms.setValue(termsList);

    updatePostHocSupplier(ui, context);
};

var containsCovariate = function(value, covariates) {
    for (var i = 0; i < covariates.length; i++) {
        if (FormatDef.term.contains(value, covariates[i]))
            return true;
    }

    return false;
};

var updateContrasts = function(ui, variableList, context) {
    var currentList = context.cloneArray(ui.contrasts.value(), []);

    var list3 = [];
    for (let i = 0; i < variableList.length; i++) {
        let found = null;
        for (let j = 0; j < currentList.length; j++) {
            if (currentList[j].var === variableList[i]) {
                found = currentList[j];
                break;
            }
        }
        if (found === null)
            list3.push({ var: variableList[i], type: "none" });
        else
            list3.push(found);
    }

    ui.contrasts.setValue(list3);
};

var filterCells = function(ui, context) {
    if (context._factorCells === null)
        return;

    var cells = context.cloneArray(ui.rmCells.value(), []);

    var factorCells = context.clone(context._factorCells);

    var changed = false;
    for (var j = 0; j < factorCells.length; j++) {
        if (j < cells.length && cells[j] !== null) {
            if (rma_cell.isEqual(cells[j].cell, factorCells[j]) === false) {
                cells[j].cell = factorCells[j];
                changed = true;
            }
        }
        else {
            cells[j] = { measure: null, cell: factorCells[j] };
            changed = true;
        }
    }

    if (cells.length > factorCells.length) {
        cells.splice(factorCells.length, cells.length - factorCells.length);
        changed = true;
    }

    if (changed) {
        ui.rmCells.setValue(cells);
        ui.rmCells.setPropertyValue("maxItemCount", cells.length);
    }
};


module.exports = events;

},{"./rmacell":3}],2:[function(require,module,exports){

// This file is an automatically generated and should not be edited

'use strict';

const options = [{"name":"data","type":"Data"},{"name":"rm","title":"Repeated Measures Factors","type":"Array","default":[{"label":"RM Factor 1","levels":["Level 1","Level 2"]}],"template":{"type":"Group","elements":[{"name":"label","type":"String"},{"name":"levels","type":"Array","template":{"type":"String"}}]},"description":{"ui":"the repeated measures design.\n","R":"a list of lists, where each list describes the `label` (as a string) and the `levels` (as vector of strings) of a particular repeated measures factor\n"}},{"name":"rmCells","title":"Repeated Measures Cells","type":"Array","default":null,"template":{"type":"Group","elements":[{"name":"measure","type":"Variable"},{"name":"cell","type":"Array","template":{"type":"String"}}]},"description":{"ui":"the repeated measures measurements.\n","R":"a list of lists, where each list decribes a repeated measure (as a string) from `data` defined as `measure` and the particular combination of levels from `rm` that it belongs to (as a vector of strings) defined as `cell`\n"}},{"name":"bs","title":"Between Subject Factors","type":"Variables","rejectUnusedLevels":true,"suggested":["nominal","ordinal"],"permitted":["factor"],"default":null,"description":{"ui":"the between subjects factors (optional).\n","R":"a vector of strings naming the between subjects factors from `data`\n"}},{"name":"covs","title":"Covariates","type":"Variables","suggested":["continuous"],"permitted":["numeric"],"default":null,"description":{"ui":"the covariates (specifying these makes this an ANCOVA)\n","R":"a vector of strings naming the covariates from `data`. Variables must be numeric\n"}},{"name":"bfType","title":"Bayes factor","type":"List","options":[{"name":"BF10","title":"BF₁₀"},{"name":"BF01","title":"BF₀₁"}],"default":"BF10"},{"name":"order","title":"Order","type":"List","options":[{"name":"nullModelTop","title":"Compare to null model"},{"name":"bestModelTop","title":"Compare to best model"}],"default":"nullModelTop"},{"name":"effects","title":"Effects","type":"Bool","default":false},{"name":"desc","title":"Descriptives","type":"Bool","default":false},{"name":"effectsType","title":"Effects type","type":"List","options":[{"name":"allModels","title":"Across all models"},{"name":"matchedModels","title":"Across matched models"}],"default":"allModels"},{"name":"modelTerms","title":"Model Terms","type":"Array","default":null,"template":{"type":"Group","elements":[{"name":"components","type":"Term"},{"name":"isNuisance","type":"Bool"}]}},{"name":"postHoc","title":"Post-hoc tests","type":"Array","template":{"type":"String"},"default":null},{"name":"postHocCorr","title":"Post-hoc correction","type":"Bool","default":true},{"name":"plotHz","title":"Horizontal axis","type":"String"},{"name":"plotLines","title":"Separate lines","type":"String"},{"name":"plotSep","title":"Separate plots","type":"String"},{"name":"depLabel","title":"","type":"String","default":"Dependent","description":{"ui":"the label to use for the dependent variable.\n","R":"a string (default: 'Dependent') describing the label used for the dependent variable throughout the analysis\n"}},{"name":"plotCI","title":"Credible interval","type":"Bool","default":false},{"name":"ciWidth","title":"Credible interval width","type":"Number","default":95,"min":50,"max":99.9},{"name":"rScaleFixed","title":"r scale fixed effects","type":"Number","default":0.5},{"name":"rScaleRand","title":"r scale random effects","type":"Number","default":1},{"name":"rScaleCovs","title":"r scale covariates","type":"Number","default":0.354},{"name":"sampling","title":"Samples","type":"List","options":[{"name":"auto","title":"Auto"},{"name":"manual","title":"Manual"}],"default":"auto"},{"name":"nSamples","title":"No. samples","type":"Integer","default":10000}];

const view = function() {
    
    

    View.extend({
        jus: "2.0",

        events: [

	],

	update: require('./banovarm.events').update

    }).call(this);
}

view.layout = ui.extend({

    label: "Bayesian Repeated Measures ANOVA",
    jus: "2.0",
    type: "root",
    stage: 0, //0 - release, 1 - development, 2 - proposed
    controls: [
		{
			type: DefaultControls.VariableSupplier,
			typeName: 'VariableSupplier',
			persistentItems: false,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.RMAnovaFactorsBox,
					typeName: 'RMAnovaFactorsBox',
					name: "rm",
					label: "Repeated Measures Factors",
					events: [
						{ execute: require('./banovarm.events').onChange_rm }
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					controls: [
						{
							type: DefaultControls.ListBox,
							typeName: 'ListBox',
							name: "rmCells",
							height: "large",
							events: [
								{ execute: require('./banovarm.events').onChange_rmCells }
							],
							templateName: "rmcell-template",
							template:
							{
								type: DefaultControls.LayoutBox,
								typeName: 'LayoutBox',
								targetArea: true,
								controls: [
									{
										type: DefaultControls.VariablesListBox,
										typeName: 'VariablesListBox',
										fullRowSelect: true,
										maxItemCount: 1,
										isTarget: true,
										valueKey: ["measure"],
										ghostText: "drag variable here"
									},
									{
										type: DefaultControls.Label,
										typeName: 'Label',
										format: require('./rmacell'),
										valueKey: ["cell"],
										margin: "normal",
										stretchFactor: 1,
										horizontalAlignment: "right"
									}
								]
							}							
						}
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					label: "Between Subject Factors",
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "bs",
							isTarget: true,
							height: "small",
							events: [
								{ execute: require('./banovarm.events').onChange_bs }
							]
						}
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					label: "Covariates",
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "covs",
							isTarget: true,
							height: "small",
							events: [
								{ execute: require('./banovarm.events').onChange_covs }
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.LayoutBox,
			typeName: 'LayoutBox',
			margin: "large",
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Bayes Factor",
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "bfType_BF10",
									optionName: "bfType",
									optionPart: "BF10",
									label: "BF₁₀"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "bfType_BF01",
									optionName: "bfType",
									optionPart: "BF01",
									label: "BF₀₁"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Order",
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "order_nullModelTop",
									optionName: "order",
									optionPart: "nullModelTop",
									label: "Compare to null model"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "order_bestModelTop",
									optionName: "order",
									optionPart: "bestModelTop",
									label: "Compare to best model"
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					cell: {"column":1,"row":0},
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Output",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "effects",
									controls: [
										{
											type: DefaultControls.RadioButton,
											typeName: 'RadioButton',
											name: "effectsType_allModels",
											optionName: "effectsType",
											optionPart: "allModels",
											label: "Across all models",
											enable: "(effects)"
										},
										{
											type: DefaultControls.RadioButton,
											typeName: 'RadioButton',
											name: "effectsType_matchedModels",
											optionName: "effectsType",
											optionPart: "matchedModels",
											label: "Across matched models",
											enable: "(effects)"
										}
									]
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "desc"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Model",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.VariableSupplier,
					typeName: 'VariableSupplier',
					name: "modelSupplier",
					label: "Components",
					populate: "manual",
					persistentItems: true,
					stretchFactor: 1,
					events: [
						{ onEvent: 'update', execute: require('./banovarm.events').onUpdate_modelSupplier }
					],
					controls: [
						{
							type: DefaultControls.TargetLayoutBox,
							typeName: 'TargetLayoutBox',
							transferAction: "interactions",
							stretchFactor: 2,
							controls: [
								{
									type: DefaultControls.ListBox,
									typeName: 'ListBox',
									name: "modelTerms",
									valueFilter: "unique",
									isTarget: true,
									itemDropBehaviour: "emptyspace",
									showColumnHeaders: true,
									events: [
										{ execute: require('./banovarm.events').onChange_modelTerms }
									],
									columns: [
										{
											name: "components",
											label: "Terms",
											selectable: true,
											stretchFactor: 1,
											maxWidth: 300,
											template:
											{
												type: DefaultControls.TermLabel,
												typeName: 'TermLabel'
											}											
										},
										{
											name: "isNuisance",
											label: "Null",
											selectable: false,
											stretchFactor: 0.3,
											template:
											{
												type: DefaultControls.CheckBox,
												typeName: 'CheckBox',
												label: "",
												horizontalAlignment: "center"
											}											
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Post-Hoc Tests",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.VariableSupplier,
					typeName: 'VariableSupplier',
					populate: "manual",
					name: "postHocSupplier",
					persistentItems: false,
					stretchFactor: 1,
					events: [
						{ onEvent: 'update', execute: require('./banovarm.events').onUpdate_postHocSupplier }
					],
					controls: [
						{
							type: DefaultControls.TargetLayoutBox,
							typeName: 'TargetLayoutBox',
							controls: [
								{
									type: DefaultControls.ListBox,
									typeName: 'ListBox',
									name: "postHoc",
									isTarget: true,
									template:
									{
										type: DefaultControls.VariableLabel,
										typeName: 'VariableLabel'
									}									
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Correction",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "postHocCorr",
									label: "Null control"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Descriptive Plots",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.VariableSupplier,
					typeName: 'VariableSupplier',
					name: "plotsSupplier",
					populate: "manual",
					persistentItems: false,
					stretchFactor: 1,
					events: [
						{ onEvent: 'update', execute: require('./banovarm.events').onUpdate_plotsSupplier }
					],
					controls: [
						{
							type: DefaultControls.TargetLayoutBox,
							typeName: 'TargetLayoutBox',
							label: "Horizontal axis",
							controls: [
								{
									type: DefaultControls.ListBox,
									typeName: 'ListBox',
									name: "plotHz",
									maxItemCount: 1,
									isTarget: true,
									template:
									{
										type: DefaultControls.VariableLabel,
										typeName: 'VariableLabel'
									}									
								}
							]
						},
						{
							type: DefaultControls.TargetLayoutBox,
							typeName: 'TargetLayoutBox',
							label: "Separate lines",
							controls: [
								{
									type: DefaultControls.ListBox,
									typeName: 'ListBox',
									name: "plotLines",
									maxItemCount: 1,
									isTarget: true,
									template:
									{
										type: DefaultControls.VariableLabel,
										typeName: 'VariableLabel'
									}									
								}
							]
						},
						{
							type: DefaultControls.TargetLayoutBox,
							typeName: 'TargetLayoutBox',
							label: "Separate plots",
							controls: [
								{
									type: DefaultControls.ListBox,
									typeName: 'ListBox',
									name: "plotSep",
									maxItemCount: 1,
									isTarget: true,
									template:
									{
										type: DefaultControls.VariableLabel,
										typeName: 'VariableLabel'
									}									
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Display",
							controls: [
								{
									type: DefaultControls.TextBox,
									typeName: 'TextBox',
									name: "depLabel",
									format: FormatDef.string,
									label: "Label y-axis",
									width: "largest"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "plotCI",
									label: "Credible interval",
									controls: [
										{
											type: DefaultControls.TextBox,
											typeName: 'TextBox',
											name: "ciWidth",
											label: "Interval",
											format: FormatDef.number,
											suffix: "%",
											enable: "(plotCI)"
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Advanced Options",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Prior",
							controls: [
								{
									type: DefaultControls.TextBox,
									typeName: 'TextBox',
									name: "rScaleFixed",
									format: FormatDef.number
								},
								{
									type: DefaultControls.TextBox,
									typeName: 'TextBox',
									name: "rScaleRand",
									format: FormatDef.number
								},
								{
									type: DefaultControls.TextBox,
									typeName: 'TextBox',
									name: "rScaleCovs",
									format: FormatDef.number
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Samples",
							cell: {"row":0,"column":1},
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "sampling_auto",
									optionName: "sampling",
									optionPart: "auto",
									label: "Auto"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "sampling_manual",
									optionName: "sampling",
									optionPart: "manual",
									label: "Manual",
									controls: [
										{
											type: DefaultControls.TextBox,
											typeName: 'TextBox',
											name: "nSamples",
											label: "No. samples",
											format: FormatDef.number,
											enable: "(sampling_manual)"
										}
									]
								}
							]
						}
					]
				}
			]
		}
	]
});

module.exports = { view : view, options: options };

},{"./banovarm.events":1,"./rmacell":3}],3:[function(require,module,exports){


var rma_cell = new Format ({

    name: 'rma_cell',

    default: [],

    toString: function(raw) {
        var r = raw[0];
        for (var i = 1; i < raw.length; i++)
            r = r + ", " + raw[i];
        return r;
    },

    parse: function(value) {
        throw "need to implement";
        return value;
    },

    isValid: function(raw) {
        if (raw === null)
            return true;

        if (Array.isArray(raw) === false)
            return false;

        for (var i = 0; i < raw.length; i++) {
            if (typeof(raw[i]) !== 'string')
                return false;
        }

        return true;
    },

    isEmpty: function(raw) {
        return raw === null || raw.length === 0;
    },

    isEqual: function(raw1, raw2) {

        if (raw1.length !== raw2.length)
            return false;

        for (var i = 0; i < raw1.length; i++) {
            if (raw1[i] !== raw2[i])
                return false;
        }

        return true;
    }
});


module.exports = rma_cell;

},{}]},{},[2])(2)
});